﻿using System;
using MongoDB.Bson.Serialization;

namespace TestMongoDbSerialization
{
	class Program
	{
		static void Main(string[] args)
		{
			var type = typeof(DerivedClass);

			if (BsonClassMap.IsClassMapRegistered(type))
				return;

			var cm = new BsonClassMap(type);
			cm.AutoMap();

			BsonClassMap.RegisterClassMap(cm);

			Console.WriteLine("If you can read this, everything went well!");
			Console.ReadLine();
		}
	}

	public abstract class BaseClass
	{
		public Guid Id { get; private set; }

		protected BaseClass(Guid id)
		{
			Id = id;
		}
	}

	public class DerivedClass : BaseClass
	{
		public DerivedClass(Guid id) : base(id) { }
	}
}
